/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package producentkonzument;

/**
 *
 * @author balikm1
 */
public class Sklad {

    private int items[];
    private int top, bottom;
    private boolean full;
    private boolean skladOtevren;

    public Sklad(int size)
    {
        items = new int[size];
        top = bottom = 0;
        skladOtevren = true;
    }

    synchronized public void put(int item)
    {
        try
        {
            while (full && isSkladOtevren())
            {
                System.out.println("Sklad je plny, cekam...");
                wait();
            }
            items[top] = item;
            System.out.println("Polozka " + item + " vlozena do skladu");
            top++; top %= items.length;
            if (top == bottom) full = true;
            notifyAll();
        } catch (InterruptedException e)
        {
            System.out.println("Sklad: Doslo k preruseni.");
        }
    }

    synchronized public int get()
    {
        int result = -1;
        try {
            while(top == bottom && !full && isSkladOtevren())   // empty
            {
                System.out.println("Sklad je prazdny, cekam...");
                wait();
            }
            result = items[bottom];
            System.out.println("Polozka " + result + " vyzvednuta ze skladu");
            bottom++; bottom %= items.length;
            full = false;
            notifyAll();
        } catch (InterruptedException e)
        {
            System.out.println("Sklad: Doslo k preruseni.");
        }
        return result;
    }

    synchronized public boolean isSkladOtevren() {
        return skladOtevren;
    }

    synchronized public void setSkladOtevren(boolean skladOtevren) {
        this.skladOtevren = skladOtevren;
        notifyAll();
    }

}
